SWITCHA
from Your Sinclair #3 (Mar.1986)
by Max Phillips


Source Listing
This is the source to Switcha - you can assemble it with your own assembler and
then save it with SAVE "SWITCHCODE" CODE 64842,177. If you make any big
changes, drop the ORG address and Ramtop to make room - the vectore table
from FDFDh to FF00h hates being overwritten!

          org 64842
hook      ld hl,ff00h
          ld bc,00fdh
loop      ld (hl),c
          dec hl
          djnz loop
          ld (hl),c

Set up interrupt vector table.

          dec hl
          ld a,enter DIV 256
          ld (hl),a
          dec hl
          ld a,enter MOD 256
          ld (hl),a
          dec hl
          ld a,c3h
          ld (hl),a

Put JP instruction to handler at FDFDh.

          ld de,hook-32768
          ld hl,hook
          ld bc,65535-hook
          ldir

Copy Switcha & UDGs into low 16K.

          ld a,127
          ld (23676),a

Adjust UDG pointer.

          rlca
          ld i,a
          im 2
          ret

Start interrupts & return to Basic. I=FEh

enter     push af
          ld a,(count-32768)
          and a
          jr z,checkey

Are we initing?

          inc a
          ld (count-32768),a
          jr nz,go4it

If yes, go and do a copy.

          ld (count),a
          ld (count-16384),a

Kill the init counter in all the partitions.

checkey   ld a,(0000)
          cp f3h
          jr nz,skipit

Check the Spectrum ROM is there. If not, return straight away.

          ld a,7fh
          in a,feh
          and 3
          jr z,go4it

Look for Symbol-Shift / Space and do a switch if it's pressed.

skipit    pop af
          jr exit

Restore registers & exit.

go4it     push hl
          push de
          push bc
          push ix
          push iy
          exx
          push af
          push hl
          push de
          push bc
          ld (spsav-32768),sp

Save the Z80 registers.

          ld a,(count-32768)
          ld c,a

Get the init count in C.

          ld de,(exbase)
          ld hl,4000h

Set up pointers for exchange.

xloop     ld a,1
          out (feh),a

Make the border blue.

          ld a,(de)
          ld b,(hl)
          ex de,hl
          ld (hl),b
          bit 7,c
          jr nz,dontx
          ld (de),a
dontx     ex de,hl
          inc de
          inc hl

Exchange 2 bytes. Just copy up if we're initing.

          ld a,4
          out (feh),a

Make the border green.

          bit 7,h
          jr z,xloop

Loop until done the whole 16K.

          ld a,d
          and 40h
          or 80h
          ld (exbase+1),a

Switch the value of EXBASE.

          ld a,(23624)
          srl a
          srl a
          srl a
          out (feh),a

Restore the border colour.

          ld sp,(spsav-32768)
          pop bc
          pop de
          pop hl
          pop af
          exx
          pop iy
          pop ix
          pop bc
          pop de
          pop hl
          pop af
exit      jp 38h

Restore all the registers and exit via the normal interrupt handler.

exbase    defb 00h,c0h
count     defb fdh
spsave    defs 2
          end

Data space.
EXBASE = partition to switch next.
COUNT  = init count (FDh to start).
SPSAV  = space for stack pointer.


--
Another Fine Product transcribed by:
Jim Grimwood (jimg@globalnet.co.uk), Weardale, England
--
